import type { ReadOnlyGraph } from "metro";
import type { MixedSourceMap } from "metro-source-map";
import type { ModuleMap } from "./gatherModules";
export type Options = {
    ignoredModules?: string[];
    bannedModules?: string[];
    throwOnError?: boolean;
};
export type Result = {
    banned: number;
    duplicates: number;
};
export declare const defaultOptions: Options;
export declare function countCopies(module: ModuleMap[string]): number;
export declare function printModule(module: ModuleMap[string]): void;
export declare function detectDuplicatePackages(bundledModules: ModuleMap, { ignoredModules, bannedModules }: Options): Result;
export declare function checkForDuplicateDependencies(graph: ReadOnlyGraph, options?: Options): Result;
export declare function checkForDuplicatePackages(sourceMap: MixedSourceMap, options?: Options): Result;
//# sourceMappingURL=checkForDuplicatePackages.d.ts.map