import type { ReadOnlyGraph } from "metro";
import type { BasicSourceMap, IndexMap, MixedSourceMap } from "metro-source-map";
type ModuleInfo = {
    name: string;
    version: string;
    absolutePath: string;
};
export type ModuleMap = Record<string, Record<string, Set<string>>>;
export declare function normalizePath(p: string): string;
export declare function resolveModule(source: string): ModuleInfo;
export declare function gatherModulesFromSections(sections: IndexMap["sections"], moduleMap: ModuleMap): ModuleMap;
export declare function gatherModulesFromSources(sources: BasicSourceMap["sources"], moduleMap: ModuleMap): ModuleMap;
export declare function gatherModulesFromGraph(graph: ReadOnlyGraph, moduleMap: ModuleMap): ModuleMap;
export declare function gatherModulesFromSourceMap(sourceMap: MixedSourceMap, moduleMap: ModuleMap): ModuleMap;
export {};
//# sourceMappingURL=gatherModules.d.ts.map