"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizePath = normalizePath;
exports.resolveModule = resolveModule;
exports.gatherModulesFromSections = gatherModulesFromSections;
exports.gatherModulesFromSources = gatherModulesFromSources;
exports.gatherModulesFromGraph = gatherModulesFromGraph;
exports.gatherModulesFromSourceMap = gatherModulesFromSourceMap;
const package_1 = require("@rnx-kit/tools-node/package");
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
function normalizePath(p) {
    return p.replaceAll("webpack:///", "").replace(/[\\]+/g, "/");
}
function resolveModule(source) {
    const pkg = (0, package_1.findPackageDir)(source);
    if (!pkg) {
        throw new Error(`Unable to resolve module '${source}'`);
    }
    const { name, version } = (0, package_1.readPackage)(pkg);
    if (!name) {
        // Packages using [dual-publish](https://github.com/ai/dual-publish), like
        // [nanoid](https://github.com/ai/nanoid), have a 'package.json' in _all_
        // folders, confusing 'pkg-dir'. We have no choice but to try again with the
        // parent directory.
        return resolveModule(path.dirname(pkg));
    }
    return { name, version, absolutePath: fs.realpathSync.native(pkg) };
}
function gatherModulesFromSections(sections, moduleMap) {
    sections.forEach((section) => gatherModulesFromSourceMap(section.map, moduleMap));
    return moduleMap;
}
function gatherModulesFromSources(sources, moduleMap) {
    sources.forEach((source) => {
        const normalizedPath = normalizePath(source);
        if (normalizedPath.toLowerCase().includes("node_modules/")) {
            const { name, version, absolutePath } = resolveModule(normalizedPath);
            if (!moduleMap[name]) {
                moduleMap[name] = {};
            }
            if (!moduleMap[name][version]) {
                moduleMap[name][version] = new Set();
            }
            moduleMap[name][version].add(absolutePath);
        }
    });
    return moduleMap;
}
function gatherModulesFromGraph(graph, moduleMap) {
    const sources = Array.from(graph.dependencies.keys());
    return gatherModulesFromSources(sources, moduleMap);
}
function gatherModulesFromSourceMap(sourceMap, moduleMap) {
    if ("sources" in sourceMap) {
        gatherModulesFromSources(sourceMap.sources, moduleMap);
    }
    if ("sections" in sourceMap) {
        gatherModulesFromSections(sourceMap.sections, moduleMap);
    }
    return moduleMap;
}
//# sourceMappingURL=gatherModules.js.map